rem Use on windows, build and run simple demo like RunDemo.bat annotation etc.

cls
@echo OFF
cd /d %~dp0

set exec_dir=%~dp0
echo %exec_dir%

set input_param=%*
if not defined input_param (
echo Please input parameter.
exit /b 1
)

set IS_USE_DEBUG=0
set CSPROJ_BUILD_ALL=0
set CSPROJ_BUILD_PLATFORM=x64
for %%i in (%*) do (
if "%%~i" == "dbg" (
set IS_USE_DEBUG=1
)
if "%%~i" == "all" (
set CSPROJ_BUILD_ALL=1
)
if "%%~i" == "x86" (
set CSPROJ_BUILD_PLATFORM=x86
)
if "%%~i" == "x64" (
set CSPROJ_BUILD_PLATFORM=x64
)
)

if "%IS_USE_DEBUG%" == "1" (
set build_config=dbg
) else (
set build_config=rel
)

if exist "../../lib/%CSPROJ_BUILD_PLATFORM%_vc15/fsdk.dll" (copy "..\..\lib\%CSPROJ_BUILD_PLATFORM%_vc15\fsdk.dll" "..\..\lib")
if exist "../../lib/%CSPROJ_BUILD_PLATFORM%_vc15/fsdk_dotnetcore.dll" (copy "..\..\lib\%CSPROJ_BUILD_PLATFORM%_vc15\fsdk_dotnetcore.dll" "..\..\lib")

set csproj_names_tempfile=csproj_names_temp.txt
if exist %csproj_names_tempfile% (del /q/s %csproj_names_tempfile% > nul)

set csproj_names_index=0
set dir_input_arrs=
if "%CSPROJ_BUILD_ALL%" == "1" (
for /d %%i in (%~dp0*) do if exist "%%~ni/%%~ni.csproj" echo %%~ni>>%csproj_names_tempfile%
) else (
for %%i in (%*) do if exist "%%i/%%i.csproj" echo %%~i>>%csproj_names_tempfile%
)

if not exist %csproj_names_tempfile% (
echo Please input correct parameter.
exit /b 1
)

for /f %%i in (%csproj_names_tempfile%) do dotnet clean %%i/%%i.csproj

for /f %%i in (%csproj_names_tempfile%) do dotnet build %%i/%%i.csproj

cd "%execdir%bin"

for /f %%i in (../%csproj_names_tempfile%) do (
echo. && echo %%i:
dotnet %%i.dll
)

del /q/s "..\%csproj_names_tempfile%">nul
cd ..
